Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -1547,116 +2367,220 @@
 				$smtp_addr = $smtp;
 			}
 			if (!$smtp || $bad_smtp || !t3lib_div::testInt(ini_get('smtp_port'))) {
-				$this->message($ext, 'Mail configuration is not set correctly','
-					Mail configuration is not set
-					PHP mail() function requires SMTP and smtp_port to have correct values on Windows.',
-					2);
+				$this->message($ext, 'Mail configuration is not set correctly', '
+					<p>
+						Mail configuration is not set
+						<br />
+						PHP mail() function requires SMTP and smtp_port to have
+						correct values on Windows.
+					</p>
+				', 2);
 			} else {
 				if (($smtp_addr == '127.0.0.1' || $smtp_addr == '::1') && ($_SERVER['SERVER_ADDR'] == '127.0.0.1' || $_SERVER['SERVER_ADDR'] == '::1')) {
-					$this->message($ext, 'Mail is configured (potential problem exists!)',
-						'<i>SMTP=' . $smtp . '</i> - <b>Note:</b> this server! Are you sure it runs SMTP server?
-						<i>smtp_port=' . ini_get('smtp_port') . '</i>
-						'.$this->check_mail('get_form'), 1);
+					$this->message($ext, 'Mail is configured (potential problem exists!)', '
+						<p>
+							<em>SMTP=' . $smtp . '</em> - <strong>Note:</strong>
+							this server! Are you sure it runs SMTP server?
+							<br />
+							<em>smtp_port=' . ini_get('smtp_port') . '</em>
+						</p>' . $this->check_mail('get_form') . '
+					', 1);
 				} else {
-					$this->message($ext, 'Mail is configured',
-						'<i>SMTP=' . $smtp . '</i>
-						<i>smtp_port=' . ini_get('smtp_port') . '</i>
-						'.$this->check_mail('get_form'), -1);
+					$this->message($ext, 'Mail is configured', '
+						<p>
+							<em>SMTP=' . $smtp . '</em>
+							<br />
+							<em>smtp_port=' . ini_get('smtp_port') . '</em>
+						</p>' . $this->check_mail('get_form') .'
+					', -1);
 				}
 			}
 		} elseif (!ini_get('sendmail_path')) {
-			$this->message($ext, 'Sendmail path not defined!','
-					This may be critical to TYPO3\'s use of the mail() function. Please be sure that the mail() function in your php-installation works!
-					' . $this->check_mail('get_form'),1);
+			$this->message($ext, 'Sendmail path not defined!', '
+				<p>
+					This may be critical to TYPO3\'s use of the mail() function.
+					Please be sure that the mail() function in your
+					php-installation works!
+				</p>' . $this->check_mail('get_form') . '
+			', 1);
 		} else {
 			list($prg) = explode(' ', ini_get('sendmail_path'));
 			if (!@is_executable($prg)) {
-				$this->message($ext, 'Sendmail program not found or not executable?','
-					<i>sendmail_path=' . ini_get('sendmail_path') . '</i>
-					This may be critical to TYPO3\'s use of the mail() function. Please be sure that the mail() function in your php-installation works!
-				'.$this->check_mail('get_form'), 1);
+				$this->message($ext, 'Sendmail program not found or not executable?', '
+					<p>
+						<em>sendmail_path=' . ini_get('sendmail_path') . '</em>
+						<br />
+						This may be critical to TYPO3\'s use of the mail()
+						function. Please be sure that the mail() function in
+						your php-installation works!
+					</p>' . $this->check_mail('get_form') .'
+				', 1);
 			} else {
-				$this->message($ext, 'Sendmail OK','
-					<i>sendmail_path=' . ini_get('sendmail_path') . '</i>
-				'.$this->check_mail('get_form'),-1);
+				$this->message($ext, 'Sendmail OK', '
+					<p>
+						<em>sendmail_path=' . ini_get('sendmail_path') . '</em>
+					</p>' . $this->check_mail('get_form') . '
+				', -1);
 			}
 		}
 
 			// *****************
 			// Safe mode related
 			// *****************
-		if (ini_get('safe_mode'))	{
-			$this->message($ext, 'Safe mode turned on',"
-				<i>safe_mode=".ini_get('safe_mode')."</i>
-				In safe_mode PHP is restricted in several ways. This is a good thing because it adds protection to your (and others) scripts. But it may also introduce problems. In TYPO3 this <em>may be</em> a problem in two areas: File administration and execution of external programs, in particular ImageMagick.
-				If you just ignore this warning, you'll most likely find, that TYPO3 seems to work except from the image-generation. The problem in that case is that the external ImageMagick programs are not allowed to be executed from the regular paths like \"/usr/bin/\" or \"/usr/X11R6/bin/\".
-				If you use safe_mode with TYPO3, you should disable use of external programs ([BE][disable_exec_function]=1).
-				In safe mode you must ensure that all the php-scripts and upload folders are owned by the same user.
-
-					<i>safe_mode_exec_dir=".ini_get('safe_mode_exec_dir')."</i>
-					If the ImageMagick utilities are located in this directory, everything is fine. Below on this page, you can see if ImageMagick is found here. If not, ask you ISP to put the three ImageMagick programs, 'convert', 'combine'/'composite' and 'identify' there (eg. with symlinks if Unix server)
-
-
+		if (ini_get('safe_mode')) {
+			$this->message($ext, 'Safe mode turned on', '
+				<p>
+					<em>safe_mode=' . ini_get('safe_mode') . '</em>
+					<br />
+					In safe_mode PHP is restricted in several ways. This is a
+					good thing because it adds protection to your (and others)
+					scripts. But it may also introduce problems. In TYPO3 this
+					<em>may be</em> a problem in two areas: File administration
+					and execution of external programs, in particular
+					ImageMagick.
+					<br />
+					If you just ignore this warning, you\'ll most likely find,
+					that TYPO3 seems to work except from the image-generation.
+					The problem in that case is that the external ImageMagick
+					programs are not allowed to be executed from the regular
+					paths like "/usr/bin/" or "/usr/X11R6/bin/".
+					<br />
+					If you use safe_mode with TYPO3, you should disable use of
+					external programs ([BE][disable_exec_function]=1).
+					<br />
+					In safe mode you must ensure that all the php-scripts and
+					upload folders are owned by the same user.
+				</p>
+				<p>
+					<em>safe_mode_exec_dir=' . ini_get('safe_mode_exec_dir') . '</em>
+					<br />
+					If the ImageMagick utilities are located in this directory,
+					everything is fine. Below on this page, you can see if
+					ImageMagick is found here. If not, ask you ISP to put the
+					three ImageMagick programs, \'convert\',
+					\'combine\'/\'composite\' and \'identify\' there (eg. with
+					symlinks if Unix server)
+				</p>
+				<p>
 					<strong>Example of safe_mode settings:</strong>
+					<br />
 					Set this in the php.ini file:
-
+				</p>
+				<p>
 					; Safe Mode
-					safe_mode               =       On
-					safe_mode_exec_dir      = /usr/bin/
-
-					...and the ImageMagick '/usr/bin/convert' will be executable.
-					The last slash is important (..../) and you can only specify one directory.
-
+					<br />
+					safe_mode = On
+					<br />
+					safe_mode_exec_dir = /usr/bin/
+				</p>
+				<p>
+					...and the ImageMagick \'/usr/bin/convert\' will be
+					executable.
+					<br />
+					The last slash is important (..../) and you can only specify
+					one directory.
+				</p>
+				<p>
 					<strong>Notice: </strong>
-					ImageMagick 4.2.9 is recommended and the binaries are normally installed by RPM in /usr/X11R6/bin or by compiling in /usr/local/bin. Please look in the \"Inside TYPO3\" pdf-document for extensive information about ImageMagick issues.
-					Paths to ImageMagick are defined in localconf.php and may be something else than /usr/bin/, but this is default for ImageMagick 5+
-
-
-			",2);
-			if (ini_get('doc_root'))	{
-				$this->message($ext, 'doc_root set',"
-					<i>doc_root=".ini_get('doc_root')."</i>
-					PHP cannot execute scripts outside this directory. If that is a problem is please correct it.
-				",1);
+					<br />
+					ImageMagick 4.2.9 is recommended and the binaries are
+					normally installed by RPM in /usr/X11R6/bin or by compiling
+					in /usr/local/bin. Please look in the "Inside TYPO3"
+					pdf-document for extensive information about ImageMagick issues.
+					<br />
+					Paths to ImageMagick are defined in localconf.php and may be
+					something else than /usr/bin/, but this is default for
+					ImageMagick 5+
+				</p>
+			', 2);
+			if (ini_get('doc_root')) {
+				$this->message($ext, 'doc_root set', '
+					<p>
+						<em>doc_root=' . ini_get('doc_root') . '</em>
+						<br />
+						PHP cannot execute scripts outside this directory. If
+						that is a problem is please correct it.
+					</p>
+				', 1);
 			}
 			$this->config_array['safemode']=1;
-		} else $this->message($ext, 'safe_mode: off',"",-1);
-		if (ini_get('sql.safe_mode'))	{
-			$this->message($ext, 'sql.safe_mode is enabled',"
-				<i>sql.safe_mode=".ini_get('sql.safe_mode').'</i>
-				This means that you can only connect to the database with a username corresponding to the user of the webserver process or fileowner. Consult your ISP for information about this. Also see '.$this->linkIt('http://www.wrox.com/Consumer/Store/Books/2963/29632002.htm').'
-				The owner of the current file is: <strong>'.get_current_user ()."</strong>
-			",1);
+		} else {
+			$this->message($ext, 'safe_mode: off',"",-1);
+		}
+		if (ini_get('sql.safe_mode')) {
+			$this->message($ext, 'sql.safe_mode is enabled', '
+				<p>
+					<em>sql.safe_mode=' . ini_get('sql.safe_mode') . '</em>
+					<br />
+					This means that you can only connect to the database with a
+					username corresponding to the user of the webserver process
+					or fileowner. Consult your ISP for information about this.
+					Also see <a href="http://www.wrox.com/Consumer/Store/Books/2963/29632002.htm">
+					http://www.wrox.com/Consumer/Store/Books/2963/29632002.htm</a>
+					<br />
+					The owner of the current file is:
+					<strong>' . get_current_user () . '</strong>
+				</p>
+			', 1);
 			$this->config_array['sql.safe_mode_user'] = get_current_user();
-		} else $this->message($ext, 'sql.safe_mode: off',"",-1);
-		if (ini_get('open_basedir'))	{
-			$this->message($ext, 'open_basedir set',"
-				<i>open_basedir=".ini_get('open_basedir')."</i>
-				This restricts TYPO3 to open and include files only in this path. Please make sure that this does not prevent TYPO3 from running.
-				<strong>Notice (UNIX):</strong> Before checking a path according to open_basedir, PHP resolves all symbolic links.
-			",1);
-//	????			If this option was set falsely you probably didn't see this page in the first place, but this option <strong>may spoil this configuration test</strong> when checking for such as ImageMagick executables.
-		} else $this->message($ext, 'open_basedir: off',"",-1);
+		} else {
+			$this->message($ext, 'sql.safe_mode: off',"",-1);
+		}
+		if (ini_get('open_basedir')) {
+			$this->message($ext, 'open_basedir set', '
+				<p>
+					<em>open_basedir=' . ini_get('open_basedir') . '</em>
+					<br />
+					This restricts TYPO3 to open and include files only in this
+					path. Please make sure that this does not prevent TYPO3 from
+					running.
+					<br />
+					<strong>Notice (UNIX):</strong> Before checking a path
+					according to open_basedir, PHP resolves all symbolic links.
+				</p>
+			', 1);
+			//	???? If this option was set falsely you probably didn't see this page in the
+			// first place, but this option <strong>may spoil this configuration test</strong>
+			//  when checking for such as ImageMagick executables.
+		} else {
+			$this->message($ext, 'open_basedir: off',"",-1);
+		}
 
 			// Check availability of PHP session support
 		if (extension_loaded('session')) {
-			$this->message($ext, 'PHP sessions availiable','
-				<i>PHP Sessions availiabe</i>
-				PHP is compiled with session support and session support is available.
-			',-1);
+			$this->message($ext, 'PHP sessions availiable', '
+				<p>
+					<em>PHP Sessions availiabe</em>
+					<br />
+					PHP is compiled with session support and session support is
+					available.
+				</p>
+			', -1);
 		} else {
-			$this->message($ext, 'PHP Sessions not availiabe','
-				PHP is not compiled with session support, or session support is disabled in php.ini.
-				TYPO3 needs session support
-			',3);
+			$this->message($ext, 'PHP Sessions not availiabe', '
+				<p>
+					PHP is not compiled with session support, or session support
+					is disabled in php.ini.
+					<br />
+					TYPO3 needs session support
+				</p>
+			', 3);
 		}
 
-				// Suhosin/Hardened PHP:
-		$suhosinDescription = 'Suhosin limits the number of elements that can be submitted in forms to the server. ' .
-			'This will affect for example the "All configuration" section in the Install Tool or Inline Relational ' .
-			'Record Editing (IRRE) with many child records.';
+			// Suhosin/Hardened PHP:
+		$suhosinDescription = '
+			<p>
+				Suhosin limits the number of elements that can be submitted in
+				forms to the server. This will affect for example the
+				"All configuration" section in the Install Tool or Inline
+				Relational Record Editing (IRRE) with many child records.
+			</p>';
 		if (extension_loaded('suhosin')) {
-			$suhosinSuggestion = 'At least a value of 400 is suggested.';
+			$suhosinSuggestion = '
+				<p>
+					At least a value of 400 is suggested.
+				</p>
+			';
 
 			$suhosinRequestMaxVars = ini_get('suhosin.request.max_vars');
 			$suhosinPostMaxVars = ini_get('suhosin.post.max_vars');
@@ -1674,13 +2598,24 @@
 			// Check for stripped PHPdoc comments that are required to evaluate annotations:
 		$method = new ReflectionMethod('tx_install', 'check_mail');
 		if (strlen($method->getDocComment()) === 0) {
-			$description = 'The system extension Extbase evaluates annotations in PHPdoc comments ' .
-				'and thus requires eAccelerator not to strip away these parts. However, this is currently ' .
-				'the only part in the TYPO3 Core (beside deprecation log and unit tests). If Extbase is not ' .
-				'used, recompiling eAccelerator is not required at all.<br/><br/>' .
-				'If you do not want comments to be stripped by eAccelerator, please recompile with the following ' .
-				'configuration setting (<a href="http://eaccelerator.net/ticket/229" target="_blank">more details</a>):<br />' .
-				'<i>--with-eaccelerator-doc-comment-inclusion</i>';
+			$description = '
+				<p>
+					The system extension Extbase evaluates annotations in PHPdoc
+					comments and thus requires eAccelerator not to strip away
+					these parts. However, this is currently the only part in the
+					TYPO3 Core (beside deprecation log and unit tests). If
+					Extbase is not used, recompiling eAccelerator is not
+					required at all.
+					<br/>
+					<br/>
+					If you do not want comments to be stripped by eAccelerator,
+					please recompile with the following configuration setting
+					(<a href="http://eaccelerator.net/ticket/229" target="_blank">
+					more details</a>):
+					<br />
+					<em>--with-eaccelerator-doc-comment-inclusion</em>
+				</p>
+			';
 			$this->message($ext, 'PHPdoc comments are stripped', $description, 2);
 		}
 	}
@@ -1688,23 +2623,65 @@
 	/**
 	 * Check if PHP function mail() works
 	 *
-	 * @param	string		$cmd	If "get_form" then a formfield for the mail-address is shown. If not, it's checked if "check_mail" was in the INSTALL array and if so a test mail is sent to the recipient given.
-	 * @return	[type]		...
+	 * @param string $cmd If "get_form" then a formfield for the mail-address is shown. If not, it's checked if "check_mail" was in the INSTALL array and if so a test mail is sent to the recipient given.
+	 * @return string The mail form if it is requested with get_form
 	 */
-	function check_mail($cmd='')	{
-		switch($cmd)	{
+	function check_mail($cmd='') {
+		switch($cmd) {
 			case 'get_form':
-				$out='
-				You can check the mail() function by entering your email address here and press the button. You should then receive a testmail from test@test.test.<br /> Since almost all mails in TYPO3 are sent using the t3lib_htmlmail class, sending with this class can be tested by checking the box <strong>Test t3lib_htmlmail</strong> below. The return-path of the mail is set to null@'.t3lib_div::getIndpEnv('HTTP_HOST').'. Some mail servers won\'t send the mail if the host of the return-path is not resolved correctly.
-				<form action="'.$this->action.'" method="post"><input type="text" name="TYPO3_INSTALL[check_mail]"><br /><input type="checkbox" name="TYPO3_INSTALL[use_htmlmail]" id="use_htmlmail" ><label for="use_htmlmail">Test t3lib_htmlmail.</label>
-					<input type="submit" value="Send test mail"></form>';
+				$out = '
+					<p id="checkMailForm">
+						You can check the mail() function by entering your email
+						address here and press the button. You should then
+						receive a testmail from test@test.test.
+						<br />
+						Since almost all mails in TYPO3 are sent using the
+						t3lib_htmlmail class, sending with this class can be
+						tested by checking the box
+						<strong>Test t3lib_htmlmail</strong> below.
+						The return-path of the mail is set to null@' . t3lib_div::getIndpEnv('HTTP_HOST') . '.
+						Some mail servers won\'t send the mail if the host of
+						the return-path is not resolved correctly.
+					</p>
+				';
+					// Get the template file
+				$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckMail.html');
+					// Get the template part from the file
+				$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+
+				if (!empty($this->mailMessage)) {
+						// Get the subpart for the mail is sent message
+					$mailSentSubpart = $this->contentObject->getSubpart($template, '###MAILSENT###');
+				}
+					// Substitute the subpart for the mail is sent message
+				$template = $this->contentObject->substituteSubpart(
+					$template,
+					'###MAILSENT###',
+					$mailSentSubpart
+				);
+					// Define the markers content
+				$markers = array(
+					'message' => $this->mailMessage,
+					'enterEmail' => 'Enter the email address',
+					'actionUrl' => $this->action . '#checkMailForm',
+					'useHtmlMailLabel' => 'Test t3lib_htmlmail',
+					'submit' => 'Send test mail'
+				);
+					// Fill the markers
+				$out .= $this->contentObject->substituteMarkerArray(
+					$template,
+					$markers,
+					'###|###',
+					1,
+					1
+				);
 			break;
 			default:
-				if (trim($this->INSTALL['check_mail']))	{
+				if (trim($this->INSTALL['check_mail'])) {
 					$subject = 'TEST SUBJECT';
 					$email = trim($this->INSTALL['check_mail']);
 
-					if($this->INSTALL['use_htmlmail'])	{
+					if($this->INSTALL['use_htmlmail']) {
 					  	$emailObj = t3lib_div::makeInstance('t3lib_htmlmail');
 					  	/* @var $emailObj t3lib_htmlmail */
 						$emailObj->start();
@@ -1718,7 +2695,7 @@
 					} else {
 						t3lib_div::plainMailEncoded($email,$subject,'TEST CONTENT','From: test@test.test');
 					}
-					$this->messages[]= 'MAIL WAS SENT TO: '.$email;
+					$this->mailMessage= 'Mail was sent to: ' . $email;
 				}
 			break;
 		}
@@ -1728,14 +2705,14 @@
 	/**
 	 * Checking php extensions, specifically GDLib and Freetype
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function checkExtensions()	{
+	function checkExtensions() {
 		$ext = 'GDLib';
 		$this->message($ext);
 
 		$software_info=1;
-		if (extension_loaded('gd') && $this->isGD())	{
+		if (extension_loaded('gd') && $this->isGD()) {
 			$this->config_array['gd']=1;
 			$this->message($ext, 'GDLib found',"",-1);
 			if ($this->isPNG()) {
@@ -1750,49 +2727,109 @@
 				$this->config_array['gd_jpg']=1;
 				$this->message($ext, 'JPG supported (not used by TYPO3)','');
 			}
-			if (!$this->config_array['gd_gif'] && !$this->config_array['gd_png'])	{
-				$this->message($ext, 'PNG or GIF not supported', nl2br(trim('
-					Your GDLib supports either GIF nor PNG. It must support either one of them.
-				')), 2);
+			if (!$this->config_array['gd_gif'] && !$this->config_array['gd_png']) {
+				$this->message($ext, 'PNG or GIF not supported', '
+					<p>
+						Your GDLib supports either GIF nor PNG. It must support
+						either one of them.
+					</p>
+				', 2);
 			} else {
 				$msg=array();
 				if ($this->config_array['gd_gif'] && $this->config_array['gd_png'])		{
-					$msg[0]='You can choose between generating GIF or PNG files, as your GDLib supports both.';
+					$msg[] = '
+						<p>
+							You can choose between generating GIF or PNG files,
+							as your GDLib supports both.
+						</p>
+					';
 				}
 				if ($this->config_array['gd_gif'])		{
-					$msg[10]="You should watch out for the generated size of the GIF-files because some versions of the GD library do not compress them with LZW, but RLE and ImageMagick is subsequently used to compress with LZW. But in the case of ImageMagick failing this task (eg. not being compiled with LZW which is the case with some versions) you'll end up with GIF-filesizes all too big!
-					This install tool tests what kinds of GIF compression are available in the ImageMagick installations by a physical test. You can also check it manually by opening a TYPO3 generated gif-file with Photoshop and save it in a new file. If the file sizes of the original and the new file are almost the same, you're having LZW compression and everything is fine.";
+					$msg[] = '
+						<p>
+							You should watch out for the generated size of the
+							GIF-files because some versions of the GD library do
+							not compress them with LZW, but RLE and ImageMagick
+							is subsequently used to compress with LZW. But in
+							the case of ImageMagick failing this task (eg. not
+							being compiled with LZW which is the case with some
+							versions) you\'ll end up with GIF-filesizes all too
+							big!
+							<br />
+							This install tool tests what kinds of GIF
+							compression are available in the ImageMagick
+							installations by a physical test. You can also check
+							it manually by opening a TYPO3 generated gif-file
+							with Photoshop and save it in a new file. If the
+							file sizes of the original and the new file are
+							almost the same, you\'re having LZW compression and
+							everything is fine.
+						</p>
+					';
 				}
 				if ($this->config_array['gd_png'])		{
-					$msg[20]='TYPO3 prefers the use of GIF-files and most likely your visitors on your website does too as not all browsers support PNG yet.';
+					$msg[] = '
+						<p>
+							TYPO3 prefers the use of GIF-files and most likely
+							your visitors on your website does too as not all
+							browsers support PNG yet.
+						</p>
+					';
 				}
-				$this->message($ext, 'GIF / PNG issues', nl2br(trim(implode($msg,chr(10)))), 1);
+				$this->message($ext, 'GIF / PNG issues', implode($msg, chr(10)), 1);
 			}
-			if (!$this->isTTF())	{
-				$this->message($ext, 'FreeType is apparently not installed', "
-					It looks like the FreeType library is not compiled into GDLib. This is required when TYPO3 uses GDLib and you'll most likely get errors like 'ImageTTFBBox is not a function' or 'ImageTTFText is not a function'.
-				", 2);
+			if (!$this->isTTF()) {
+				$this->message($ext, 'FreeType is apparently not installed', '
+					<p>
+						It looks like the FreeType library is not compiled into
+						GDLib. This is required when TYPO3 uses GDLib and
+						you\'ll most likely get errors like \'ImageTTFBBox is
+						not a function\' or \'ImageTTFText is not a function\'.
+					</p>
+				', 2);
 			} else {
-				$this->message($ext, 'FreeType quick-test ('.($this->isGIF()?'as GIF':'as PNG').')', '<img src="'.htmlspecialchars(t3lib_div::getIndpEnv('REQUEST_URI').'&testingTrueTypeSupport=1').'" alt=""><br />(If the text is exceeding the image borders you are using Freetype 2 and need to set TYPO3_CONF_VARS[GFX][TTFdpi]=96.<br />If there is no image at all Freetype is most likely NOT available and you can just as well disable GDlib for TYPO3...)', -1);
+				$this->message($ext, 'FreeType quick-test (' . ($this->isGIF() ? 'as GIF' : 'as PNG') . ')', '
+					<p>
+						<img src="' . htmlspecialchars(t3lib_div::getIndpEnv('REQUEST_URI') . '&testingTrueTypeSupport=1') . '" alt="" />
+						<br />
+						(If the text is exceeding the image borders you are
+						using Freetype 2 and need to set
+						TYPO3_CONF_VARS[GFX][TTFdpi]=96.
+						<br />
+						If there is no image at all Freetype is most likely NOT
+						available and you can just as well disable GDlib for
+						TYPO3...)
+					</p>
+				', -1);
 				$this->config_array['freetype']=1;
 			}
 		} else {
-			$this->message($ext, 'GDLib not found', "
-				GDLib is required if you want to use the GIFBUILDER object in TypoScript. GIFBUILDER is in charge of all advanced image generation in TypoScript, including graphical menuitems.
-				GDLib is also used in the TYPO3 Backend (TBE) to generate record icons and new module tabs.
-				It's highly recommended to install this library. Remember to compile GD with FreeType which is also required.
-				If you choose not to install GDLib, you can disable it in the configuration with [GFX][gdlib]=0;.
-			", 2);
+			$this->message($ext, 'GDLib not found', '
+				<p>
+					GDLib is required if you want to use the GIFBUILDER object
+					in TypoScript. GIFBUILDER is in charge of all advanced image
+					generation in TypoScript, including graphical menuitems.
+					<br />
+					GDLib is also used in the TYPO3 Backend (TBE) to generate
+					record icons and new module tabs.
+					<br />
+					It\'s highly recommended to install this library. Remember
+					to compile GD with FreeType which is also required.
+					<br />
+					If you choose not to install GDLib, you can disable it in
+					the configuration with [GFX][gdlib]=0;.
+				</p>
+			', 2);
 		}
-		$this->message($ext, 'GDLib software information', nl2br(trim($this->getGDSoftwareInfo())));
+		$this->message($ext, 'GDLib software information', $this->getGDSoftwareInfo());
 	}
 
 	/**
 	 * Checking and testing that the required writable directories are writable.
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function checkDirs()	{
+	function checkDirs() {
 		// Check typo3/temp/
 		$ext='Directories';
 		$this->message($ext);
@@ -1825,42 +2862,52 @@
 			$GLOBALS['TYPO3_CONF_VARS']['BE']['fileadminDir'] . '_temp_/' => array('Typical temporary location for default upload of files by administrators.',0),
 		);
 
-		foreach ($checkWrite as $relpath => $descr)	{
+		foreach ($checkWrite as $relpath => $descr) {
 
 				// Check typo3temp/
 			$general_message = $descr[0];
 
-			if (!@is_dir(PATH_site.$relpath))	{	// If the directory is missing, try to create it
+				// If the directory is missing, try to create it
+			if (!@is_dir(PATH_site.$relpath)) {
 				t3lib_div::mkdir(PATH_site.$relpath);
 			}
 
-			if (!@is_dir(PATH_site.$relpath))	{
-				if ($descr[1])	{	// required...
-					$this->message($ext, $relpath.' directory does not exist and could not be created','
-					<em>Full path: '.PATH_site.$relpath.'</em>
-					'.$general_message.'
-
-					This error should not occur as '.$relpath.' must always be accessible in the root of a TYPO3 website.
-					',3);
+			if (!@is_dir(PATH_site.$relpath)) {
+				if ($descr[1]) {	// required...
+					$this->message($ext, $relpath.' directory does not exist and could not be created', '
+						<p>
+							<em>Full path: ' . PATH_site . $relpath . '</em>
+							<br />
+							' . $general_message . '
+						</p>
+						<p>
+							This error should not occur as ' . $relpath . ' must
+							always be accessible in the root of a TYPO3 website.
+						</p>
+					', 3);
 				} else {
-					if ($descr[1] == 0)	{
+					if ($descr[1] == 0) {
 						$msg = 'This directory does not necessarily have to exist but if it does it must be writable.';
 					} else {
 						$msg = 'This directory does not necessarily have to exist and if it does it can be writable or not.';
 					}
-					$this->message($ext, $relpath.' directory does not exist','
-					<em>Full path: '.PATH_site.$relpath.'</em>
-					'.$general_message.'
-
-					'.$msg.'
-					',2);
+					$this->message($ext, $relpath.' directory does not exist', '
+						<p>
+							<em>Full path: ' . PATH_site . $relpath . '</em>
+							<br />
+							' . $general_message . '
+						</p>
+						<p>
+							' . $msg . '
+						</p>
+					', 2);
 				}
 			} else {
 				$file = PATH_site.$relpath.$uniqueName;
 				@touch($file);
-				if (@is_file($file))	{
+				if (@is_file($file)) {
 					unlink($file);
-					if ($descr[2])	{ $this->config_array[$descr[2]]=1; }
+					if ($descr[2]) { $this->config_array[$descr[2]]=1; }
 					$this->message($ext, $relpath.' writable','',-1);
 				} else {
 					$severity = ($descr[1]==2 || $descr[1]==0) ? 3 : 2;
@@ -1869,13 +2916,19 @@
 					} elseif ($descr[1] == -1 || $descr[1] == 1) {
 						$msg = 'The directory '.$relpath.' does not neccesarily have to be writable.';
 					}
-					$this->message($ext, $relpath.' directory not writable','
-					<em>Full path: '.$file.'</em>
-					'.$general_message.'
-
-					Tried to write this file (with touch()) but didn\'t succeed.
-					'.$msg.'
-					',$severity);
+					$this->message($ext, $relpath .' directory not writable', '
+						<p>
+							<em>Full path: ' . $file . '</em>
+							<br />
+							' . $general_message . '
+						</p>
+						<p>
+							Tried to write this file (with touch()) but didn\'t
+							succeed.
+							<br />
+							' . $msg . '
+						</p>
+					', $severity);
 				}
 			}
 		}
@@ -1886,36 +2939,41 @@
 	 *
 	 * This tries to find available ImageMagick installations and tries to find the version numbers by executing "convert" without parameters. If the ->checkIMlzw is set, LZW capabilities of the IM installs are check also.
 	 *
-	 * @param	[type]		$paths: ...
-	 * @return	[type]		...
+	 * @param array $paths Possible ImageMagick paths
+	 * @return void
 	 */
-	function checkImageMagick($paths)	{
+	function checkImageMagick($paths) {
 		$ext='Check Image Magick';
 		$this->message($ext);
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'CheckImageMagick.html');
 
 		$paths = array_unique($paths);
 
 		$programs = explode(',','gm,convert,combine,composite,identify');
 		$isExt = TYPO3_OS=="WIN" ? ".exe" : "";
 		$this->config_array['im_combine_filename']='combine';
-		reset($paths);
-		while(list($k,$v)=each($paths))	{
-			reset($programs);
+		foreach ($paths as $k => $v) {
 			if (!preg_match('/[\\/]$/',$v)) $v.='/';
-			while(list(,$filename)=each($programs))	{
+			foreach ($programs as $filename) {
 				if (ini_get('open_basedir') || (file_exists($v)&&@is_file($v.$filename.$isExt))) {
 					$version = $this->_checkImageMagick_getVersion($filename,$v);
-					if($version > 0)	{
-						if($filename=='gm')	{	// Assume GraphicsMagick
+					if($version > 0) {
+							// Assume GraphicsMagick
+						if($filename=='gm') {
 							$index[$v]['gm']=$version;
-							continue;	// No need to check for "identify" etc.
-						} else	{	// Assume ImageMagick
+								// No need to check for "identify" etc.
+							continue;
+						} else	{
+								// Assume ImageMagick
 							$index[$v][$filename]=$version;
 						}
 					}
 				}
 			}
-			if (count($index[$v])>=3 || $index[$v]['gm'])	{ $this->config_array['im']=1; }
+			if (count($index[$v])>=3 || $index[$v]['gm']) {
+				$this->config_array['im'] = 1;
+			}
 
 			if ($index[$v]['gm'] || (!$index[$v]['composite'] && $index[$v]['combine'])) {
 				$this->config_array['im_combine_filename']='combine';
